---
- hosts: service
  become: yes
  tasks:

    - name: Download Consul from Yandex
      ansible.builtin.get_url:
        url: https://hashicorp-releases.yandexcloud.net/consul/1.14.3/consul_1.14.3_linux_amd64.zip
        dest: /root/
        mode: '0755'
        force: no

    - name: Install required system packages
      apt:
        pkg:
          - python3-pip
          - unzip
          - docker.io
          - prometheus-node-exporter
        state: latest
        update_cache: true

    - name: Install Docker Module for Python
      pip:
        name: docker
      
    - name: Create build directory
      file:
        path: /root/demo
        state: directory
        owner: root
        group: root
        mode: '0755'

    - name: Create consul.d directory
      file:
        path: /etc/consul.d
        state: directory
        owner: root
        group: root
        mode: '0755'

    - name: Copy src/service dir
      copy:
        src: ../src/service/
        dest: /root/demo/
        owner: root
        group: root
        mode: '0755'

    - name: Copy Consul file services.json
      copy:
        src: /root/demo/services.json
        dest: /etc/consul.d/
        owner: root
        group: root
        mode: '0755'
        force: yes
        remote_src: yes

    - name: Copy service file mydocker.service 
      copy:
        src: /root/demo/mydocker.service
        dest: /etc/systemd/system/
        owner: root
        group: root
        mode: '0755'
        remote_src: yes

    - name: Restart service Rsyslog
      ansible.builtin.service:
        name: rsyslog
        state: restarted

    - name: Stop service mydocker
      ansible.builtin.service:
        name: mydocker
        state: stopped

    - name: Remove the old containers if exist
      docker_container:
        name: myapplication
        state: absent

    - name: Remove the old images of skillbox/app
      community.docker.docker_image:
        state: absent
        force_absent: true
        name: petrakimovdocker/skillboxapp:latest

    - name: Pull the image
      community.docker.docker_image:
        name: petrakimovdocker/skillboxapp:latest
        source: pull

    - name: Start service mydocker, if not started
      ansible.builtin.service:
        name: mydocker
        state: started        

#    - name: Download and unarchive node_exporter
#      ansible.builtin.unarchive:
#        src: https://github.com/prometheus/node_exporter/releases/download/v1.5.0/node_exporter-1.5.0.linux-amd64.tar.gz
#        dest: /root/
#        remote_src: yes

#    - name: Run node exporter
#      shell: nohup /root/node_exporter-1.5.0.linux-amd64/node_exporter --web.listen-address=0.0.0.0:9100 &
